; ##############################################################################
; ##############################################################################
; ##############################################################################
DIAGRAMM_ALARM:
	LDS temp,(adr_BMA020_ALARM_TIMER)
	cpi temp,255
	breq DIAGRAMM_ALARM_RUN
	ret
;-------------------------------------------------------------------------------
DIAGRAMM_ALARM_RUN:
	LDS temp1,(adr_BMA020_X_L)
	LDS temp2,(adr_BMA020_X_H)
	rcall DIAGRAMM_ALARM_AUWERTUNG_TEMP1_TEMP2
	LDS temp1,(adr_BMA020_Y_L)
	LDS temp2,(adr_BMA020_Y_H)
	rcall DIAGRAMM_ALARM_AUWERTUNG_TEMP1_TEMP2
	LDS temp1,(adr_BMA020_Z_L)
	LDS temp2,(adr_BMA020_Z_H)
	rcall DIAGRAMM_ALARM_AUWERTUNG_TEMP1_TEMP2
	ret
;-------------------------------------------------------------------------------
DIAGRAMM_ALARM_AUWERTUNG_TEMP1_TEMP2:
	tst temp2
	brpl DIAGRAMM_ALARM_AUWERTUNG_TEMP1_TEMP2_w
	com temp1
	com temp2
	add temp1,EINS
	adc temp2,NULL
DIAGRAMM_ALARM_AUWERTUNG_TEMP1_TEMP2_w:
	tst temp2
	brne DIAGRAMM_ALARM_AUWERTUNG_TEMP1_TEMP2_AKTION
	LDS temp,(adr_BMA020_ALARM_SCHWELLE)
	cp temp1,temp
	brsh DIAGRAMM_ALARM_AUWERTUNG_TEMP1_TEMP2_AKTION
	ret
;-------------------------------------------------------------------------------
DIAGRAMM_ALARM_AUWERTUNG_TEMP1_TEMP2_AKTION:
	cbi (LED_GELB_PORT),LED_GELB_PIN_NR			; GELB an	
	ldi temp,254
	STS(adr_BMA020_ALARM_TIMER),temp
	ldi temp,0b10000000
	STS(adr_TV_BILDBEREICH_ENDE-45*1),temp
	STS(adr_TV_BILDBEREICH_ENDE-45*2),temp
	STS(adr_TV_BILDBEREICH_ENDE-45*3),temp
	STS(adr_TV_BILDBEREICH_ENDE-45*4),temp
	STS(adr_TV_BILDBEREICH_ENDE-45*5),temp
	STS(adr_TV_BILDBEREICH_ENDE-45*6),temp
	STS(adr_TV_BILDBEREICH_ENDE-45*7),temp
	STS(adr_TV_BILDBEREICH_ENDE-45*8),temp
	STS(adr_TV_BILDBEREICH_ENDE-45*9),temp
	STS(adr_TV_BILDBEREICH_ENDE-45*10),temp
ret
; ##############################################################################
; ##############################################################################
; ##############################################################################
DIAGRAMM_ZEICHNEN:
	LDS temp,(adr_BMA020_ALARM_TIMER)
	cpi temp,255
	breq DIAGRAMM_ZEICHNEN_w1	; mit Uhrzeit	
	tst temp
	brne DIAGRAMM_ZEICHNEN_w2	; TIMER dec		
	ret
;-------------------------------------------------------------------------------
DIAGRAMM_ZEICHNEN_w2:
	dec temp
	STS(adr_BMA020_ALARM_TIMER),temp
	rjmp DIAGRAMM_ZEICHNEN_RUN
;-------------------------------------------------------------------------------
DIAGRAMM_ZEICHNEN_w1:
	; ZEIT+DATUM				
	LDS temp,(adr_FREIGABE_DIAGRAMM_ZEIT)
	SBRS temp,0
	rjmp DIAGRAMM_ZEICHNEN_RUN
	STS(adr_FREIGABE_DIAGRAMM_ZEIT),NULL
	call ASCII_CURSOR_ZEILE_1
	call ANZEIGE_ZEIT_KURZ
	call ASCII_SPACE2
	call ANZEIGE_WOCHENTAG_KURZ
	call ASCII_SPACE2
	call ANZEIGE_DATUM_KURZ
;-------------------------------------------------------------------------------
DIAGRAMM_ZEICHNEN_RUN:
	; SEKUNDENMARKIERUNG unten	
	LDS temp,(adr_FREIGABE_DIAGRAMM_MARKIERUNG)
	SBRS temp,0
	rjmp DIAGRAMM_ZEICHNEN_RUN_w 
	STS(adr_FREIGABE_DIAGRAMM_MARKIERUNG),NULL
	LDS temp,(adr_TV_BILDBEREICH_ENDE)
	ori temp,0b10000000
	STS(adr_TV_BILDBEREICH_ENDE),temp
;-------------------------------------------------------------------------------
DIAGRAMM_ZEICHNEN_RUN_w:
	ldi XL,LOW (360-1)		; positionieren	X
	ldi XH,HIGH(360-1)

	LDS YL,(adr_BMA020_X_L)
	LDS YH,(adr_BMA020_X_H)
;	LSL YL					; x2
;	ROL YH
	subi YL, LOW (-150)		; positionieren	Y
	sbci YH, HIGH(-150)
	rcall GRAFIC_PUNKT_X_Y

	LDS YL,(adr_BMA020_Y_L)
	LDS YH,(adr_BMA020_Y_H)
;	LSL YL					; x2
;	ROL YH
	subi YL, LOW (-100)		; positionieren	Y
	sbci YH, HIGH(-100)
	rcall GRAFIC_PUNKT_X_Y

	LDS YL,(adr_BMA020_Z_L)
	LDS YH,(adr_BMA020_Z_H)
;	LSL YL					; x2
;	ROL YH
	subi YL, LOW (-50)		; positionieren	Y
	sbci YH, HIGH(-50)
	rcall GRAFIC_PUNKT_X_Y

	rjmp DIAGRAMM_SCHIEBEN
; ##############################################################################
; ##############################################################################
; ##############################################################################
.MACRO MACRO_SCHIEBEN_BYTES10
	MACRO_SCHIEBEN_BYTES
	MACRO_SCHIEBEN_BYTES
	MACRO_SCHIEBEN_BYTES
	MACRO_SCHIEBEN_BYTES
	MACRO_SCHIEBEN_BYTES
	MACRO_SCHIEBEN_BYTES
	MACRO_SCHIEBEN_BYTES
	MACRO_SCHIEBEN_BYTES
	MACRO_SCHIEBEN_BYTES
	MACRO_SCHIEBEN_BYTES
.endm
; ##############################################################################
.MACRO MACRO_SCHIEBEN_BYTES
	LD temp,Z	; laden				
	ROR temp	; rechts ber Carry	
	ST Z,temp	; speichern			
	LD R0,-Z	; DUMMY Z-1			
.endm
; ##############################################################################
; ##############################################################################
; ##############################################################################
; nur den Diagramm-Bereich schieben, aber nicht die obere ASCII-ZEILE			
DIAGRAMM_SCHIEBEN:
	; Z auf Bildbereich-ENDE
	ldi ZL,LOW (adr_TV_BILDBEREICH_ENDE)
	ldi ZH,HIGH(adr_TV_BILDBEREICH_ENDE)
	ldi temp9,232	; (256-24)
DIAGRAMM_SCHIEBEN_s:
	rcall DIAGRAMM_SCHIEBEN_ZEILE
	dec temp9
	brne DIAGRAMM_SCHIEBEN_s
ret
;-------------------------------------------------------------------------------
DIAGRAMM_SCHIEBEN_ZEILE:
	CLC	; Clear Carry
	MACRO_SCHIEBEN_BYTES10
	MACRO_SCHIEBEN_BYTES10
	MACRO_SCHIEBEN_BYTES10
	MACRO_SCHIEBEN_BYTES10
	MACRO_SCHIEBEN_BYTES
	MACRO_SCHIEBEN_BYTES
	MACRO_SCHIEBEN_BYTES
	MACRO_SCHIEBEN_BYTES
	MACRO_SCHIEBEN_BYTES
ret
; ##############################################################################
; ##############################################################################
; ##############################################################################
